--[[

Author: skyraker
File: MyStatusWindow.lua
Thanks: Qwexton(DragonLoot), Bazgrim and Wykkyd(Toolbar), Seerah(libStub et al), Xrystal (XrysGatherer), and others
]]--

---------------------------- ADDON LOCALS ------------------------------
local EM = EVENT_MANAGER
local initialized = 0
local LMP = LibStub:GetLibrary("LibMediaProvider-1.0")
local bt = {}
local MSWSavedVars = MSWSavedVars or {}
local orderedList = {"EXP","Gold","BagSpace","Time","FPS","SkillPoints","Location","Zone","BankMoney","RepairCost","Mail","AP","AchievePoint","HorseTimer","SpecXP","AvA"}
---------------------------------------------------------------------------

---------------------------------------------- HELPER FUNCTIONS ---------------------------
--[[ MyStatWin.delayBuffer: buffer function of OnUpdate handler ]]--
local function delayBuffer(key, buffer)
	if key == nil then return end
	if bt[key] == nil then bt[key] = {} end
	bt[key].buffer = buffer or 3
	bt[key].now = GetFrameTimeMilliseconds()
	if bt[key].last == nil then bt[key].last = bt[key].now end
	bt[key].diff = bt[key].now - bt[key].last
	bt[key].eval = bt[key].diff >= bt[key].buffer
	if bt[key].eval then bt[key].last = bt[key].now end
	return bt[key].eval
end

local function setWin(name,alpha,edger,edgeg,edgeb,edgea,cete,ceng,cenb,cena,edgeTname,edgeTa,edgeTb,edgeTc,dimx,dimy)
	if alpha then name:SetAlpha(alpha) end
	name:SetEdgeColor(edger,edgeg,edgeb,edgea)
	name:SetCenterColor(cenr,ceng,cenb,cena)
	name:SetEdgeTexture(edgeTname,edgeTa,edgeTb,edgeTc)
	name:SetDimensions(dimx,dimy)
end

local function barSettings()
	if not MSWSavedVars.Settings.dragBarLoc then
		MyStatusWindow:ClearAnchors()
		MyStatusWindow:SetAnchor(TOPLEFT,GuiXml,TOPLEFT,MSWSavedVars.Settings.barOffset.X,MSWSavedVars.Settings.barOffset.Y)
		MyStatusWindow:SetDimensions(MSWSavedVars.Settings.barDimensions.X,MSWSavedVars.Settings.barDimensions.Y)
		MyStatWin_BG2:SetHandler("OnMouseUp", function(self) MyStatWin.savePosition() end )
		setWin(MyStatWin_BG2,MSWSavedVars.Settings.barColor.alpha,0,0,0,0,MSWSavedVars.Settings.barColor.r,MSWSavedVars.Settings.barColor.g,MSWSavedVars.Settings.barColor.b,MSWSavedVars.Settings.barColor.a,"",1,1,1,MSWSavedVars.Settings.barDimensions.X,6)
		setWin(MyStatWin_BG,MSWSavedVars.Settings.currAlpha,0,0,0,0,0,0,0,1,"",1,1,1,MSWSavedVars.Settings.barDimensions.X,20)
	else
		MyStatusWindow:ClearAnchors()
		MyStatusWindow:SetAnchor(TOPLEFT,GuiXml,TOPLEFT,MSWSavedVars.Settings.barOffset.X,MSWSavedVars.Settings.barOffset.Y)
		MyStatusWindow:SetDimensions(MSWSavedVars.Settings.barDimensions.X,MSWSavedVars.Settings.barDimensions.Y)
		MyStatWin_BG2:ClearAnchors()
		MyStatWin_BG2:SetAnchor(BOTTOMLEFT,MyStatusWindow,BOTTOMLEFT)
		MyStatWin_BG2:SetHandler("OnMouseUp", function(self) MyStatWin.savePosition() end )
		MyStatWin_BG:ClearAnchors()
		MyStatWin_BG:SetAnchor(BOTTOMLEFT,MyStatWin_BG2,TOPLEFT)
		setWin(MyStatWin_BG2,MSWSavedVars.Settings.barColor.alpha,0,0,0,0,MSWSavedVars.Settings.barColor.r,MSWSavedVars.Settings.barColor.g,MSWSavedVars.Settings.barColor.b,MSWSavedVars.Settings.barColor.a,"",1,1,1,MSWSavedVars.Settings.barDimensions.X,6)
		setWin(MyStatWin_BG,MSWSavedVars.Settings.currAlpha,0,0,0,0,0,0,0,1,"",1,1,1,MSWSavedVars.Settings.barDimensions.X,20)		
	end
	setWin(MSW_XPBar_BG1,nil,0,0,.75,.65,0,0,0,.6,"",8,1,1,100,10)
	setWin(MSW_XPBar_BG2,nil,0,0,0,0,.6,1,.6,.95,"",8,1,1,MyStatWin.globals.Data.xpPct,10)
	MSW_XPBar_Text:SetText("XP:")
	MSW_XPBar_Text:SetFont(("%s|%s|%s"):format(LMP:Fetch('font', MSWSavedVars.Settings.usedFont), MSWSavedVars.Settings.currFontSize, MSWSavedVars.Settings.currStyle))
	if MSWSavedVars.Modules.XPBar == false then
		MSW_XPBar:SetHidden(true)
	else
		MSW_XPBar:SetHidden(false)
	end
end
-----------------------------------------------------------------------------

--------------------------------------- SETTINGS FUNCTIONS ----------------------------
local function adjustCompass()
	if MSWSavedVars.Settings.bumpLock then
		if MyStatusWindow:GetTop() <= 80 then
			if ZO_CompassFrame:GetTop() ~= MyStatusWindow:GetTop() + 60 then
				ZO_CompassFrame:ClearAnchors()
				ZO_CompassFrame:SetAnchor( TOP, GuiRoot, TOP, 0, MyStatusWindow:GetTop() + 60)
				ZO_TargetUnitFramereticleover:ClearAnchors()
				ZO_TargetUnitFramereticleover:SetAnchor( TOP, GuiRoot, TOP, 0, MyStatusWindow:GetTop() + 108)
			end
		elseif MyStatusWindow:GetTop() <= 100 then
			ZO_TargetUnitFramereticleover:ClearAnchors()
			ZO_TargetUnitFramereticleover:SetAnchor( TOP, GuiRoot, TOP, 0, MyStatusWindow:GetTop() + 40)
		else
			if ZO_CompassFrame:GetTop() ~= 40 then
				ZO_CompassFrame:ClearAnchors()
				ZO_CompassFrame:SetAnchor( TOP, GuiRoot, TOP, 0, 40 )
				ZO_TargetUnitFramereticleover:ClearAnchors()
				ZO_TargetUnitFramereticleover:SetAnchor( TOP, GuiRoot, TOP, 0, 88 )
			end
		end
	end
end

--[[ MyStatWin.savePosition: saves the bars position when moved ]]--
function MyStatWin.savePosition()
	local left = 0
	local top = 0
	if not MSWSavedVars.Settings.dragBarLoc then
		left = math.floor(MyStatWin_BG2:GetLeft())
		top = math.floor(MyStatWin_BG2:GetTop())
	else
		left = math.floor(MyStatWin_BG:GetLeft())
		top = math.floor(MyStatWin_BG:GetTop())
	end
	if left < 0 then left = 0 end
	if top < 0 then top = 0 end
	MSWSavedVars.Settings.barOffset.X = left
	MSWSavedVars.Settings.barOffset.Y = top
	MyStatusWindow:ClearAnchors()
	MSW_XPBar:ClearAnchors()
	MyStatusWindow:SetAnchor(TOPLEFT,GuiXML,TOPLEFT,MSWSavedVars.Settings.barOffset.X,MSWSavedVars.Settings.barOffset.Y)
	MSW_XPBar:SetAnchor(TOPLEFT,MyStatWin_BG,TOPRIGHT)
	adjustCompass()
end

------------------------------------------------------------------------------------

--------------------------- ADDON MAIN FUNCTIONS ----------------------------------
--[[ MyStatusWindowUpdate called every frame update. ]]--
function MyStatWin.MyStatusWindowUpdate()
	if not delayBuffer("MyStatusWindowUpdate", 2) then return; end
	if (initialized == 1) then
		MyStatWin.buildToolbar()
	end
end
------------------------------------------------------------------------------------

--------------------------------------- INITIALIZATION FUNCTIONS -----------------------------
--[[ MyStatWin.Initialize: called when addon loaded event fires. Sets up saved vars, registers for events needed for updates, and sets variables to initial values --]]
function MyStatWin.Initialize( code, addOnName )
	if ( addOnName ~= "MyStatusWindow" ) then return end
	EM:UnregisterForEvent("MyStatWin",code)
	MSWSavedVars = MyStatWin.setupSavedVars()
	MyStatWin.registerEvents()
	initialized = 1
	barSettings()
	toolText:SetFont(("%s|%s|%s"):format(LMP:Fetch('font', MSWSavedVars.Settings.usedFont), MSWSavedVars.Settings.currFontSize, MSWSavedVars.Settings.currStyle))
	adjustCompass()
end

---------------------------------------------------------------------------------------------------

--------------------------------------- ADDON ENTRY FUNCTION ---------------------------------
EVENT_MANAGER:RegisterForEvent( "MyStatWin" , EVENT_ADD_ON_LOADED , MyStatWin.Initialize )
------------------------------------------------------------------------------------------------