local LAM = LibStub:GetLibrary("LibAddonMenu-1.0")
local LMP = LibStub:GetLibrary("LibMediaProvider-1.0")
local newFont = LMP:Register('font',"DejaVu Sans Mono", "MyStatusWindow/dejavusansmono.ttf")
local fontList = LMP:List('font')
local fontStyles = {"normal", "outline", "thick-outline", "shadow", "soft-shadow-thick", "soft-shadow-thin"}
local WM = WINDOW_MANAGER
local MSWSavedVars = MSWSavedVars or {}
local EM = EVENT_MANAGER
local orderedList = {"EXP","Gold","BagSpace","Time","FPS","SkillPoints","Location","Zone","BankMoney","RepairCost","Mail","AP","AchievePoint","HorseTimer","SpecXP","AvA","XPBar"}

local function createLabel(name,parent,dimX,dimY,text,font,color,vertAlign,anchor)
	local label = {}
	local colorR,colorG,colorB,colorA = unpack(color)
	local anchorWOM,anchorTC,anchorWOT,anchorOX,anchorOY = unpack(anchor)
	label = WM:CreateControl(name,parent,CT_LABEL)
	label:SetDimensions(dimX,dimY)
	label:SetText(text)
	label:SetFont(font)
	label:SetColor(colorR,colorG,colorB,colorA)
	label:SetVerticalAlignment(vertAlign)
	label:SetAnchor(anchorWOM,anchorTC,anchorWOT,anchorOX,anchorOY)
	return label
end

local function createButton(id,parent,dimX,dimY,font,anchor,normColor,overColor)
	local button = {}
	local anchorWOM,anchorTC,anchorWOT,anchorOX,anchorOY = unpack(anchor)
	local ncolorR,ncolorG,ncolorB,ncolorA = unpack(normColor)
	local ocolorR,ocolorG,ocolorB,ocolorA = unpack(overColor)
	button = WM:CreateControl(id, parent,CT_BUTTON)
	button:SetDimensions(dimX,dimY)
	button:SetFont(font)
	button:SetAnchor(anchorWOM,anchorTC,anchorWOT,anchorOX,anchorOY)
	button:SetNormalFontColor(ncolorR,ncolorG,ncolorB,ncolorA)
	button:SetMouseOverFontColor(ocolorR,ocolorG,ocolorB,ocolorA)
	return button
end

local function closeWindow()
	mySettings:SetHidden(true)
end

function MyStatWin.globals.Functions.ToggleLocation(buttonname)
	MSWSavedVars.Modules.Location = (not MSWSavedVars.Modules.Location)  --Flip the boolean value to true or false
	if (MSWSavedVars.Modules.Location) then
		buttonname:SetText('[X]')
		MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
		if MyStatWin.globals.Data.counter > 1 then
		end
	else 
		buttonname:SetText('[ ]')
		MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
		if MyStatWin.globals.Data.counter > 0 then
		end
	end
end

function MyStatWin.globals.Functions.ToggleXPBar(buttonname)
	MSWSavedVars.Modules.XPBar = (not MSWSavedVars.Modules.XPBar)
	if (MSWSavedVars.Modules.XPBar) then
		buttonname:SetText('[X]')
		MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
		MSW_XPBar:SetHidden(false)
	else
		buttonname:SetText('[ ]')
		MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
		MSW_XPBar:SetHidden(true)
	end
end

function MyStatWin.globals.Functions.ToggleHorseTimer(buttonname)
	MSWSavedVars.Modules.HorseTimer = (not MSWSavedVars.Modules.HorseTimer)
	if (MSWSavedVars.Modules.HorseTimer) then
		buttonname:SetText('[X]')
		MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
		if MyStatWin.globals.Data.counter > 1 then
		end
	else
		buttonname:SetText('[ ]')
		MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
		if MyStatWin.globals.Data.counter > 0 then
		end
	end
end

function MyStatWin.globals.Functions.ToggleSpecXP(buttonname)
	MSWSavedVars.Modules.SpecXP = (not MSWSavedVars.Modules.SpecXP)
	if (MSWSavedVars.Modules.SpecXP) then
		buttonname:SetText('[X]')
		MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
		if MyStatWin.globals.Data.counter > 1 then
		end
	else
		buttonname:SetText('[ ]')
		MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
		if MyStatWin.globals.Data.counter > 0 then
		end
	end
end

function MyStatWin.globals.Functions.ToggleAvA(buttonname)
	MSWSavedVars.Modules.AvA = (not MSWSavedVars.Modules.AvA)
	if (MSWSavedVars.Modules.AvA) then
		buttonname:SetText('[X]')
		MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
		if MyStatWin.globals.Data.counter > 1 then
		end
	else 
		buttonname:SetText('[ ]')
		MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
		if MyStatWin.globals.Data.counter > 0 then
		end
	end
end

function MyStatWin.globals.Functions.ToggleAP(buttonname)
	MSWSavedVars.Modules.AP = (not MSWSavedVars.Modules.AP)
	if (MSWSavedVars.Modules.AP) then
		buttonname:SetText('[X]')
		MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
		if MyStatWin.globals.Data.counter > 1 then
		end
	else 
		buttonname:SetText('[ ]')
		MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
		if MyStatWin.globals.Data.counter > 0 then
		end
	end
end

function MyStatWin.globals.Functions.ToggleRepairCost(buttonname)
	MSWSavedVars.Modules.RepairCost = (not MSWSavedVars.Modules.RepairCost)
	if (MSWSavedVars.Modules.RepairCost) then
		buttonname:SetText('[X]')
		MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
		if MyStatWin.globals.Data.counter > 1 then
		end
	else 
		buttonname:SetText('[ ]')
		MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
		if MyStatWin.globals.Data.counter > 0 then
		end
	end
end

function MyStatWin.globals.Functions.ToggleBankMoney(buttonname)
	MSWSavedVars.Modules.BankMoney = (not MSWSavedVars.Modules.BankMoney)
	if (MSWSavedVars.Modules.BankMoney) then
		buttonname:SetText('[X]')
		MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
		if MyStatWin.globals.Data.counter > 1 then
		end
	else
		buttonname:SetText('[ ]')
		MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
		if MyStatWin.globals.Data.counter > 0 then
		end
	end
end

function MyStatWin.globals.Functions.ToggleAchievePoint(buttonname)
	MSWSavedVars.Modules.AchievePoint = (not MSWSavedVars.Modules.AchievePoint)
	if (MSWSavedVars.Modules.AchievePoint) then
		buttonname:SetText('[X]')
		MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
		if MyStatWin.globals.Data.counter > 1 then
		end
	else
		buttonname:SetText('[ ]')
		MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
		if MyStatWin.globals.Data.counter > 0 then
		end
	end
end

function MyStatWin.globals.Functions.ToggleSkillPoints(buttonname)
	MSWSavedVars.Modules.SkillPoints = (not MSWSavedVars.Modules.SkillPoints)  --Flip the boolean value to true or false
	if (MSWSavedVars.Modules.SkillPoints) then
		buttonname:SetText('[X]')
		MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
		if MyStatWin.globals.Data.counter > 1 then
		end
	else 
		buttonname:SetText('[ ]')
		MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
		if MyStatWin.globals.Data.counter > 0 then
		end
	end
end

function MyStatWin.globals.Functions.ToggleGold(buttonname)
	MSWSavedVars.Modules.Gold = (not MSWSavedVars.Modules.Gold)  --Flip the boolean value to true or false
	
		if (MSWSavedVars.Modules.Gold) then
			buttonname:SetText('[X]')
			MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
			if MyStatWin.globals.Data.counter > 1 then
		end
		else 
			buttonname:SetText('[ ]')
			MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
			if MyStatWin.globals.Data.counter > 0 then
			end
		end
end

function MyStatWin.globals.Functions.ToggleBagSpace(buttonname)
	MSWSavedVars.Modules.BagSpace = (not MSWSavedVars.Modules.BagSpace)  --Flip the boolean value to true or false
	
		if (MSWSavedVars.Modules.BagSpace) then
			buttonname:SetText('[X]')
			MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
			if MyStatWin.globals.Data.counter > 1 then
			end
		else 
			buttonname:SetText('[ ]')
			MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
			if MyStatWin.globals.Data.counter > 0 then
			end
		end
end

function MyStatWin.globals.Functions.ToggleTime(buttonname)
	MSWSavedVars.Modules.Time = (not MSWSavedVars.Modules.Time)  --Flip the boolean value to true or false
	
		if (MSWSavedVars.Modules.Time) then
			buttonname:SetText('[X]')
			MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
			if MyStatWin.globals.Data.counter > 1 then
			end
		else 
			buttonname:SetText('[ ]')
			MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
			if MyStatWin.globals.Data.counter > 0 then
			end
		end
end

function MyStatWin.globals.Functions.ToggleEXP(buttonname)
	MSWSavedVars.Modules.EXP = (not MSWSavedVars.Modules.EXP)  --Flip the boolean value to true or false
	
		if (MSWSavedVars.Modules.EXP) then
			buttonname:SetText('[X]')
			MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
			if MyStatWin.globals.Data.counter > 1 then
			end
		else 
			buttonname:SetText('[ ]')
			MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
			if MyStatWin.globals.Data.counter > 0 then
			end
		end
end

function MyStatWin.globals.Functions.ToggleFPS(buttonname)
	MSWSavedVars.Modules.FPS = (not MSWSavedVars.Modules.FPS)  --Flip the boolean value to true or false
	
		if (MSWSavedVars.Modules.FPS) then
			buttonname:SetText('[X]')
			MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
			if MyStatWin.globals.Data.counter > 1 then
			end
		else 
			buttonname:SetText('[ ]')
			MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
			if MyStatWin.globals.Data.counter > 0 then
			end
		end
end

function MyStatWin.globals.Functions.ToggleZone(buttonname)
	MSWSavedVars.Modules.Zone = (not MSWSavedVars.Modules.Zone)  --Flip the boolean value to true or false
	
		if (MSWSavedVars.Modules.Zone) then
			buttonname:SetText('[X]')
			MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
			if MyStatWin.globals.Data.counter > 1 then
			end
		else 
			buttonname:SetText('[ ]')
			MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
			if MyStatWin.globals.Data.counter > 0 then
			end
		end
end

function MyStatWin.globals.Functions.ToggleMail(buttonname)
	MSWSavedVars.Modules.Mail = (not MSWSavedVars.Modules.Mail)  --Flip the boolean value to true or false
	
		if (MSWSavedVars.Modules.Mail) then
			buttonname:SetText('[X]')
			MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
			if MyStatWin.globals.Data.counter > 1 then
			end
		else 
			buttonname:SetText('[ ]')
			MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
			if MyStatWin.globals.Data.counter > 0 then
			end
		end
end

local function makeLabels()
	local name = "mySettings"
	local defColor = {1,1,1,1}
	local defMouseOverColor = {0,1,0,1}
	local lbl_offsetX = 30
	local lbl_offsetY = 60
	local btn_offsetX = -30
	local btn_offsetY = 60
	local tileoffset = 30
	local defLblAnchor = {}
	local defBtnAnchor = {}
	local labels = {"Location", "SkillPoints", "Gold", "BagSpace", "Time", "EXP", "FPS", "Zone", "Mail","AP", "AchievePoint", "RepairCost", "BankMoney", "HorseTimer", "SpecXP","AvA","XPBar"}
	for  _, label in ipairs(labels) do
		local labelname = "my_settings_" .. label 
		lablename = createLabel(label,mySettings,mySettings:GetWidth()*0.6,30,"Show "..label.."..............................................","MyStatWinFont3",defColor,1,{TOPLEFT, mySettings ,TOPLEFT,lbl_offsetX,lbl_offsetY})
		lbl_offsetY = (lbl_offsetY + tileoffset)
		local buttonname = "my_settings_btn" .. label
		local btnID = "btn_" .. label
		local toggleFunction = "Toggle" .. label
		buttonname = createButton(btnID,mySettings,25,25,"MyStatWinFont3",{TOPRIGHT,mySettings,TOPRIGHT,btn_offsetX,btn_offsetY},{1,1,1,1},{0,1,0,1})
		local buttonStr = ""..toggleFunction.."(...)"
		if (MSWSavedVars.Modules[label]) then
			buttonname:SetText('[X]')
		else 
			buttonname:SetText('[ ]')
		end
		buttonname:SetState( BSTATE_NORMAL )
		buttonname:SetHandler( "OnClicked" , function() _G["MyStatWin"]["globals"]["Functions"][toggleFunction](buttonname) end)
		btn_offsetY = (btn_offsetY + tileoffset) -- Increment the offset so that the buttons tile with the labels.		
	end
	defLblAnchor = {TOPLEFT,mySettings,TOPLEFT,lbl_offsetX,lbl_offsetY}
	defBtnAnchor = {TOPRIGHT,mySettings,TOPRIGHT,btn_offsetX,btn_offsetY}
end

------------------------------------ SETTINGS WINDOW FUNCTIONS ----------------------------
--[[ The next 8 functions are used for modifying and retrieving settings for LibAddOnMenu --]]
--[[ reloadBar: allows immediate changes to bar font settings when changed in menu ]]--
local function reloadBar()
	toolText:SetFont(("%s|%s|%s"):format(LMP:Fetch('font', MSWSavedVars.Settings.usedFont), MSWSavedVars.Settings.currFontSize, MSWSavedVars.Settings.currStyle))
	if not MSWSavedVars.Settings.dragBarLoc then
		MyStatusWindow:ClearAnchors()
		MyStatusWindow:SetAnchor(TOPLEFT,GuiXml,TOPLEFT,MSWSavedVars.Settings.barOffset.X,MSWSavedVars.Settings.barOffset.Y)
		MyStatWin_BG2:ClearAnchors()
		MyStatWin_BG2:SetAnchor(TOPLEFT,MyStatusWindow,TOPLEFT)
		MyStatWin_BG:ClearAnchors()
		MyStatWin_BG:SetAnchor(TOPLEFT,MyStatWin_BG2,BOTTOMLEFT)
	else
		MyStatusWindow:ClearAnchors()
		MyStatusWindow:SetAnchor(TOPLEFT,GuiXml,TOPLEFT,MSWSavedVars.Settings.barOffset.X,MSWSavedVars.Settings.barOffset.Y)
		MyStatusWindow:SetDimensions(MSWSavedVars.Settings.barDimensions.X,MSWSavedVars.Settings.barDimensions.Y)
		MyStatWin_BG:ClearAnchors()
		MyStatWin_BG:SetAnchor(TOPLEFT,MyStatusWindow,TOPLEFT)
		MyStatWin_BG2:ClearAnchors()
		MyStatWin_BG2:SetAnchor(TOPLEFT,MyStatWin_BG,BOTTOMLEFT)
	end
end

local function RGBToHex(r,g,b)
	r = r <= 1 and r >= 0 and r or 0
	g = g <= 1 and g >= 0 and g or 0
	b = b <= 1 and b >= 0 and b or 0
	return string.format("%02x%02x%02x", r*255, g*255, b*255)
end

local function currentAlpha()
	return MSWSavedVars.Settings.currAlpha * 10
end

local function adjustAlpha(newAlpha)
	local normAlpha = newAlpha/10.0
	MSWSavedVars.Settings.currAlpha = normAlpha
	MyStatWin_BG:SetAlpha(normAlpha)
end

local function currentFont()
	return MSWSavedVars.Settings.usedFont
end

local function setFont(newFont)
	MSWSavedVars.Settings.usedFont = newFont
	reloadBar()
end

local function currentFontSize()
	return MSWSavedVars.Settings.currFontSize
end

local function setFontSize(newSize)
	local numSpacers = 0
	local currentCount = 0
	MSWSavedVars.Settings.barDimensions.X = 25
	MSWSavedVars.Settings.currFontSize = newSize
	strFontSize = tostring(newSize)
	MSWSavedVars.Settings.fontSizing = MyStatWin.globals.fontSizing[strFontSize]
	for _,k in ipairs(orderedList) do
		if (MSWSavedVars.Modules[k]) then
			currentCount = currentCount + 1
			local modifier = MSWSavedVars.Settings.fontSizing * MyStatWin.globals.moduleSizes[k]
			MSWSavedVars.Settings.barDimensions.X = MSWSavedVars.Settings.barDimensions.X + modifier
		end
	end
	numSpacers = currentCount - 1
	if (numSpacers > 0) then MSWSavedVars.Settings.barDimensions.X = MSWSavedVars.Settings.barDimensions.X + (MyStatWin.globals.Data.spacerSize * numSpacers) end
	reloadBar()
end

local function currentStyle()
	return MSWSavedVars.Settings.currStyle
end

local function setStyle(newStyle)
	MSWSavedVars.Settings.currStyle = newStyle
	reloadBar()
end

local function getBarColor()
	return MSWSavedVars.Settings.barColor.r,MSWSavedVars.Settings.barColor.g,MSWSavedVars.Settings.barColor.b,MSWSavedVars.Settings.barColor.a
end

local function setBarColor(r,g,b,a)
	MSWSavedVars.Settings.barColor.r = r
	MSWSavedVars.Settings.barColor.g = g
	MSWSavedVars.Settings.barColor.b = b
	MSWSavedVars.Settings.barColor.a = a
	MyStatWin_BG2.SetColor(r,g,b,a)
end

function MyStatWin.createSettingsWindow()
	SkySettings = LAM:CreateControlPanel("Skyrakers_Options", MyStatWin.colors.cyan.."Skyraker's |rAddons")
	LAM:AddHeader(SkySettings, "MSW_Options", "My Status Window")
	LAM:AddCheckbox(SkySettings,"MSW_Locked","Lock position","Lock the bar in its current location",
		function ()
			return MSWSavedVars.Settings.locked
		end,
		function(checkbox)
			if checkbox then
				MyStatWin_BG2:SetMovable(false)
			else
				MyStatWin_BG2:SetMovable(true)
			end
			MSWSavedVars.Settings.locked = not MSWSavedVars.Settings.locked
		end
	)
	LAM:AddCheckbox(SkySettings,"MSW_Bump","Enable/Disable Compass Bump","Allow/prevent auto compass bumping",
		function ()
			return MSWSavedVars.Settings.bumpLock
		end,
		function(checkbox)
			MSWSavedVars.Settings.bumpLock = not MSWSavedVars.Settings.bumpLock
		end
	)
	LAM:AddCheckbox(SkySettings,"MSW_DragBarLoc","Drag Bar on Bottom","Move Drag Bar Below Info Bar",
		function()
			return MSWSavedVars.Settings.dragBarLoc
		end,
		function(checkbox)
			MSWSavedVars.Settings.dragBarLoc = not MSWSavedVars.Settings.dragBarLoc
			reloadBar()
		end
	)
	SkySettingDragBar = LAM:AddSubMenu(SkySettings,"MSW_DragBar","Drag Bar Options","Modify Drag Bar Settings")
	LAM:AddSlider(SkySettingDragBar,"MSW_DragBar_Back","Drag Bar Transparency","Adjust Transparency of Drag Bar",0,10,1,
					function() return MyStatWin_BG2:GetAlpha() * 10 end,
					function(alpha)
						MSWSavedVars.Settings.barColor.alpha = alpha / 10.0
						MyStatWin_BG2:SetAlpha(alpha/10.0)
					end)
	LAM:AddColorPicker(SkySettingDragBar,"MSW_BGColor","Drag Bar Color","Select color of drag bar",
						function() return MSWSavedVars.Settings.barColor.r,MSWSavedVars.Settings.barColor.g,MSWSavedVars.Settings.barColor.b,MSWSavedVars.Settings.barColor.a end,
						function(r,g,b,a)
							MSWSavedVars.Settings.barColor.r = r
							MSWSavedVars.Settings.barColor.g = g
							MSWSavedVars.Settings.barColor.b = b
							MSWSavedVars.Settings.barColor.a = a
							MyStatWin_BG2:SetCenterColor(r,g,b,a)
						end)
	SkySettingModules = LAM:AddSubMenu(SkySettings,"MSW_Modules","Selectable Modules","Allows user to select which modules to display on info bar.")
	LAM:AddCheckbox(SkySettingModules, "MSW_Modules_Location", "Location", "Show Current Player Position",
		function()
			return MSWSavedVars.Modules.Location
		end,
		function(checkbox)
			if checkbox then 
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
				if MyStatWin.globals.Data.counter > 1 then
				end
			else 
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
				if MyStatWin.globals.Data.counter > 0 then
				end
			end
			MSWSavedVars.Modules.Location = not MSWSavedVars.Modules.Location
		end
	)
	LAM:AddCheckbox(SkySettingModules, "MSW_Modules_RepairCost", "Repair Cost", "Show Cost To Repair Equipment",
		function()
			return MSWSavedVars.Modules.RepairCost
		end,
		function(checkbox)
			if checkbox then 
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
				if MyStatWin.globals.Data.counter > 1 then
				end
			else 
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
				if MyStatWin.globals.Data.counter > 0 then
				end
			end
			MSWSavedVars.Modules.RepairCost = not MSWSavedVars.Modules.RepairCost
		end
	)
	LAM:AddCheckbox(SkySettingModules, "MSW_Modules_BankMoney", "Banked Money", "Show Player's Money Deposited in Bank",
		function()
			return MSWSavedVars.Modules.BankMoney
		end,
		function(checkbox)
			if checkbox then 
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
				if MyStatWin.globals.Data.counter > 1 then
				end
			else 
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
				if MyStatWin.globals.Data.counter > 0 then
				end
			end
			MSWSavedVars.Modules.BankMoney = not MSWSavedVars.Modules.BankMoney
		end
	)
	LAM:AddCheckbox(SkySettingModules, "MSW_Modules_SkillPoints", "Skill Points", "Show Available Skill Points and Skyshard Status",
		function()
			return MSWSavedVars.Modules.SkillPoints
		end,
		function(checkbox)
			if checkbox then 
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
				if MyStatWin.globals.Data.counter > 1 then
				end
			else 
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
				if MyStatWin.globals.Data.counter > 0 then
				end
			end
			MSWSavedVars.Modules.SkillPoints = not MSWSavedVars.Modules.SkillPoints
		end
	)
	LAM:AddCheckbox(SkySettingModules, "MSW_Modules_Gold", "Gold", "Show Gold on Hand",
		function()
			return MSWSavedVars.Modules.Gold
		end,
		function(checkbox)
			if checkbox then 
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
				if MyStatWin.globals.Data.counter > 1 then
				end
			else 
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
				if MyStatWin.globals.Data.counter > 0 then
				end
			end
			MSWSavedVars.Modules.Gold = not MSWSavedVars.Modules.Gold
		end
	)
	LAM:AddCheckbox(SkySettingModules, "MSW_Modules_BagSpace", "Inventory Space", "Show Free/Total Inventory Space",
		function()
			return MSWSavedVars.Modules.BagSpace
		end,
		function(checkbox)
			if checkbox then 
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
				if MyStatWin.globals.Data.counter > 1 then
				end
			else 
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
				if MyStatWin.globals.Data.counter > 0 then
				end
			end
			MSWSavedVars.Modules.BagSpace = not MSWSavedVars.Modules.BagSpace
		end
	)
	LAM:AddCheckbox(SkySettingModules, "MSW_Modules_Time", "Current Time", "Show Current Local Time",
		function()
			return MSWSavedVars.Modules.Time
		end,
		function(checkbox)
			if checkbox then 
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
				if MyStatWin.globals.Data.counter > 1 then
				end
			else 
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
				if MyStatWin.globals.Data.counter > 0 then
				end
			end
			MSWSavedVars.Modules.Time = not MSWSavedVars.Modules.Time
		end
	)
	LAM:AddCheckbox(SkySettingModules, "MSW_Modules_EXP", "Experience", "Show Player Experience/Next Level Experience Required",
		function()
			return MSWSavedVars.Modules.EXP
		end,
		function(checkbox)
			if checkbox then 
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
				if MyStatWin.globals.Data.counter > 1 then
				end
			else 
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
				if MyStatWin.globals.Data.counter > 0 then
				end
			end
			MSWSavedVars.Modules.EXP = not MSWSavedVars.Modules.EXP
		end
	)
	LAM:AddCheckbox(SkySettingModules, "MSW_Modules_FPS", "Frame Rate", "Show FPS",
		function()
			return MSWSavedVars.Modules.FPS
		end,
		function(checkbox)
			if checkbox then 
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
				if MyStatWin.globals.Data.counter > 1 then
				end
			else 
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
				if MyStatWin.globals.Data.counter > 0 then
				end
			end
			MSWSavedVars.Modules.FPS = not MSWSavedVars.Modules.FPS
		end
	)
	LAM:AddCheckbox(SkySettingModules, "MSW_Modules_Zone", "Zone", "Show Player's Current Zone",
		function()
			return MSWSavedVars.Modules.Zone
		end,
		function(checkbox)
			if checkbox then 
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
				if MyStatWin.globals.Data.counter > 1 then
				end
			else 
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
				if MyStatWin.globals.Data.counter > 0 then
				end
			end
			MSWSavedVars.Modules.Zone = not MSWSavedVars.Modules.Zone
		end
	)
	LAM:AddCheckbox(SkySettingModules, "MSW_Modules_Mail", "Unread Mail", "Notify Player of Unread Mail",			
		function()
			return MSWSavedVars.Modules.Mail
		end,
		function(checkbox)
			if checkbox then 
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
				if MyStatWin.globals.Data.counter > 1 then
				end
			else 
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
				if MyStatWin.globals.Data.counter > 0 then
				end
			end
			MSWSavedVars.Modules.Mail = not MSWSavedVars.Modules.Mail
		end
	)
	LAM:AddCheckbox(SkySettingModules, "MSW_Modules_AP", "Alliance Points", "Show Player's Alliance Point Total",	
		function()
			return MSWSavedVars.Modules.AP
		end,
		function(checkbox)
			if checkbox then 
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
				if MyStatWin.globals.Data.counter > 1 then
				end
			else 
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
				if MyStatWin.globals.Data.counter > 0 then
				end
			end
			MSWSavedVars.Modules.AP = not MSWSavedVars.Modules.AP
		end
	)
	LAM:AddCheckbox(SkySettingModules, "MSW_Modules_AchievePoint", "Achievement Points", "Show Current Achievement Points Earned/Max Points Available",
		function()
			return MSWSavedVars.Modules.AchievePoint
		end,
		function(checkbox)
			if checkbox then 
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
				if MyStatWin.globals.Data.counter > 1 then
				end
			else 
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
				if MyStatWin.globals.Data.counter > 0 then
				end
			end
			MSWSavedVars.Modules.AchievePoint = not MSWSavedVars.Modules.AchievePoint
		end
	)
	LAM:AddCheckbox(SkySettingModules, "MSW_Modules_HorseTimer", "Horse Timer", "Display time til active mount must be fed",
		function()
			return MSWSavedVars.Modules.HorseTimer
		end,
		function(checkbox)
			if checkbox then 
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
				if MyStatWin.globals.Data.counter > 1 then
				end
			else 
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
				if MyStatWin.globals.Data.counter > 0 then
				end
			end
			MSWSavedVars.Modules.HorseTimer = not MSWSavedVars.Modules.HorseTimer
		end
	)
	LAM:AddCheckbox(SkySettingModules, "MSW_Modules_SpecXP", "Wolf/Vamp XP", "Show Non-Human XP Percentage",
		function()
			return MSWSavedVars.Modules.SpecXP
		end,
		function(checkbox)
			if checkbox then 
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
				if MyStatWin.globals.Data.counter > 1 then
				end
			else 
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
				if MyStatWin.globals.Data.counter > 0 then
				end
			end
			MSWSavedVars.Modules.SpecXP = not MSWSavedVars.Modules.SpecXP
		end
	)
	LAM:AddCheckbox(SkySettingModules, "MSW_Modules_AvA", "AvA Points", "Show Player's AvA points/rank",
		function()
			return MSWSavedVars.Modules.AvA
		end,
		function(checkbox)
			if checkbox then 
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
				if MyStatWin.globals.Data.counter > 1 then
				end
			else 
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
				if MyStatWin.globals.Data.counter > 0 then
				end
			end
			MSWSavedVars.Modules.AvA = not MSWSavedVars.Modules.AvA
		end
	)
	LAM:AddCheckbox(SkySettingModules, "MSW_Modules_XPBar", "XP Bar", "Display Graphical XP Bar",
		function()
			return MSWSavedVars.Modules.XPBar
		end,
		function(checkbox)
			if checkbox then
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter + 1
				MSW_XPBar:SetHidden(false)
			else
				MyStatWin.globals.Data.counter = MyStatWin.globals.Data.counter - 1
				MSW_XPBar:SetHidden(true)
			end
			MSWSavedVars.Modules.XPBar = not MSWSavedVars.Modules.XPBar
		end
	)
	SkySettingMSWEnhance = LAM:AddSubMenu(SkySettings,"MSW_Settings","Text/Background Settings","Change font settings and background transparancy.")
	LAM:AddSlider(SkySettingMSWEnhance,"MSW_Background","Background Transparency","Adjust Transparency of Add-On Background",0,10,1,currentAlpha,adjustAlpha)
	LAM:AddDropdown(SkySettingMSWEnhance,"MSW_FontSelect","Font","Change Displayed Font",fontList,currentFont,setFont)
	LAM:AddSlider(SkySettingMSWEnhance,"MSW_FontSizeSelect","Size","Change Font Size",10,20,2,currentFontSize,setFontSize)
	LAM:AddDropdown(SkySettingMSWEnhance,"MSW_FontStyleSelect","Style","Change Font Style",fontStyles,currentStyle,setStyle)
	SkySettingMSWColors = LAM:AddSubMenu(SkySettings,"MSW_Colors","Colors","Modify various info bar colors")
	LAM:AddColorPicker(SkySettingMSWColors,"MSW_NameColor","Module Name Color","Select color for modules names",
		function() return MSWSavedVars.Settings.modNameColorRGB.r,MSWSavedVars.Settings.modNameColorRGB.g,MSWSavedVars.Settings.modNameColorRGB.b,MSWSavedVars.Settings.modNameColorRGB.a end,
		function(r,g,b,a)
			MSWSavedVars.Settings.modNameColorRGB.r = r
			MSWSavedVars.Settings.modNameColorRGB.g = g
			MSWSavedVars.Settings.modNameColorRGB.b = b
			MSWSavedVars.Settings.modNameColorRGB.a = a
			MSWSavedVars.Settings.modNameColor = "|c"..RGBToHex(r,g,b)
			MyStatWin.initializeGlobals()
		end
	)
	LAM:AddColorPicker(SkySettingMSWColors,"MSW_NumColor","Module Number Color","Select color for numbers",
		function() return MSWSavedVars.Settings.modNumColorRGB.r,MSWSavedVars.Settings.modNumColorRGB.g,MSWSavedVars.Settings.modNumColorRGB.b,MSWSavedVars.Settings.modNumColorRGB.a end,
		function(r,g,b,a)
			MSWSavedVars.Settings.modNumColorRGB.r = r
			MSWSavedVars.Settings.modNumColorRGB.g = g
			MSWSavedVars.Settings.modNumColorRGB.b = b
			MSWSavedVars.Settings.modNumColorRGB.a = a
			MSWSavedVars.Settings.modNumColor = "|c"..RGBToHex(r,g,b)
			MyStatWin.initializeGlobals()
		end
	)
	LAM:AddColorPicker(SkySettingMSWColors,"MSW_TextColor","Module Text Color","Select color for modules text",
		function() return MSWSavedVars.Settings.modTextColorRGB.r,MSWSavedVars.Settings.modTextColorRGB.g,MSWSavedVars.Settings.modTextColorRGB.b,MSWSavedVars.Settings.modTextColorRGB.a end,
		function(r,g,b,a)
			MSWSavedVars.Settings.modTextColorRGB.r = r
			MSWSavedVars.Settings.modTextColorRGB.g = g
			MSWSavedVars.Settings.modTextColorRGB.b = b
			MSWSavedVars.Settings.modTextColorRGB.a = a
			MSWSavedVars.Settings.modTextColor = "|c"..RGBToHex(r,g,b)
			MyStatWin.initializeGlobals()
		end
	)
	LAM:AddColorPicker(SkySettingMSWColors,"MSW_PuncColor","Module Punctuation Color","Select color for modules punctuations(slashes, parenthesis,etc)",
		function() return MSWSavedVars.Settings.modPuncColorRGB.r,MSWSavedVars.Settings.modPuncColorRGB.g,MSWSavedVars.Settings.modPuncColorRGB.b,MSWSavedVars.Settings.modPuncColorRGB.a end,
		function(r,g,b,a)
			MSWSavedVars.Settings.modPuncColorRGB.r = r
			MSWSavedVars.Settings.modPuncColorRGB.g = g
			MSWSavedVars.Settings.modPuncColorRGB.b = b
			MSWSavedVars.Settings.modPuncColorRGB.a = a
			MSWSavedVars.Settings.modPuncColor = "|c"..RGBToHex(r,g,b)
			MyStatWin.initializeGlobals()
		end
	)
	LAM:AddColorPicker(SkySettingMSWColors,"MSW_SpaceColor","Module Spacer Color","Select color for spacer",
		function() return MSWSavedVars.Settings.modSpaceColorRGB.r,MSWSavedVars.Settings.modSpaceColorRGB.g,MSWSavedVars.Settings.modSpaceColorRGB.b,MSWSavedVars.Settings.modSpaceColorRGB.a end,
		function(r,g,b,a)
			MSWSavedVars.Settings.modSpaceColorRGB.r = r
			MSWSavedVars.Settings.modSpaceColorRGB.g = g
			MSWSavedVars.Settings.modSpaceColorRGB.b = b
			MSWSavedVars.Settings.modSpaceColorRGB.a = a
			MSWSavedVars.Settings.modSpaceColor = "|c"..RGBToHex(r,g,b)
			MyStatWin.initializeGlobals()
		end
	)
end

function MyStatWin.changeSettings()
	if (mySettings == nil) then
		my_settings = WM:CreateTopLevelWindow("mySettings")
		my_settings:SetMouseEnabled( true )
		my_settings:SetHidden( false )
		my_settings:SetMovable( true )
		my_settings:SetDimensions( 400,550 )
		my_settings:ClearAnchors()
		my_settings:SetAnchor( TOPLEFT,GuiXML,TOPLEFT,MSWSavedVars.Settings.settingsOffset.X,MSWSavedVars.Settings.settingsOffset.Y )
		my_settings:SetHandler("OnMouseUp" , function(self) MyStatWin.settingsSavePosition() end)
		my_settings_Title = WM:CreateControl("Title", mySettings, CT_LABEL)
		my_settings_Title:SetDimensions( my_settings:GetWidth() , 36 )
		my_settings_Title:SetFont( "ZoFontBookPaper" )
		my_settings_Title:SetColor(1,1,1,1)
		my_settings_Title:SetHorizontalAlignment(1)
		my_settings_Title:SetVerticalAlignment(0)
		my_settings_Title:SetText( "My Settings")
		my_settings_Title:ClearAnchors()
		my_settings_Title:SetAnchor(TOP,my_settings,TOP,0,10)
		my_settings_clsBtn = WM:CreateControl("Close" , mySettings , CT_BUTTON)
		my_settings_clsBtn:SetDimensions( 25 , 25 )
		my_settings_clsBtn:SetFont("ZoFontGameBold")
		my_settings_clsBtn:ClearAnchors()
		my_settings_clsBtn:SetAnchor(TOPRIGHT,mySettings,TOPRIGHT,-5,5)
		my_settings_clsBtn:SetNormalFontColor(1,1,1,1)
		my_settings_clsBtn:SetMouseOverFontColor(0.8,0.4,0,1)
		my_settings_clsBtn:SetText('[X]')
		my_settings_clsBtn:SetState( BSTATE_NORMAL )
		my_settings_clsBtn:SetHandler( "OnClicked" , function() closeWindow() end )
		my_settings_BG = WM:CreateControl("mySettingsBG", mySettings, CT_BACKDROP)
		my_settings_BG:SetDimensions( my_settings:GetWidth() , my_settings:GetHeight() )
		my_settings_BG:SetCenterColor(0,0,0,0.5)
		my_settings_BG:SetEdgeColor(.1,.1,.1,1)
		my_settings_BG:SetEdgeTexture("",8,1,2)
		my_settings_BG:ClearAnchors()
		my_settings_BG:SetAnchor(CENTER,mySettings,CENTER,0,0)
		makeLabels()
	else
		mySettings:SetHidden(false)
	end
end

local function Init(code, name)
	if name == "MyStatusWindow" then
		EM:UnregisterForEvent("MSW_Settings",code)
		MSWSavedVars = MyStatWin.setupSavedVars()
	end
end

EM:RegisterForEvent( "MSW_Settings" , EVENT_ADD_ON_LOADED , Init )